`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    01:27:51 04/25/2016 
// Design Name: 
// Module Name:    freq_div 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
module freq_div(
  clk_25, // divided clock output
	clk_21, // divided clock output
	clk_18, // divided clock output
	clk_ctl, // divided clock output for scan freq
	clk, // global clock input
	rst_n // active low reset
	);
	
	output clk_25,clk_21,clk_18; // divided output
	output [1:0] clk_ctl; // divided output for scan freq
		
	input clk; // global clock input
	input rst_n; // active low reset
	
	reg clk_25,clk_21,clk_18; // clk output (in always block)
	reg [1:0] clk_ctl; // clk output (in always block)
	reg [14:0] cnt_l;// temp buf of the counter
	reg [1:0]cnt_h;// temp buf of the counter
	reg [2:0] cnt_p;// temp buf of the counter
	reg [24:0] cnt_tmp; // input to dff (in always block)
	reg clk_debounce;
	
	// Combinational logics: increment, neglecting overflow 
	always @*
	cnt_tmp = {clk_25,cnt_p,clk_21,cnt_h,clk_18,clk_ctl,cnt_l} + 1'b1;
	
	// Sequential logics: Flip flops
	always @(posedge clk or negedge rst_n)
	if (~rst_n) {clk_25,cnt_p,clk_21,cnt_h,clk_18,clk_ctl,cnt_l}<=25'd0;
	else {clk_25,cnt_p,clk_21,cnt_h,clk_18,clk_ctl,cnt_l}<=cnt_tmp;



endmodule
