`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    01:19:15 04/25/2016 
// Design Name: 
// Module Name:    timer_lap_fsm 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`define STAT_TIMER 1'b0
`define STAT_LAP 1'b1
`define MODE_TIMER 1'b0
`define MODE_LAP 1'b1
module timer_lap_fsm(
   minute1,
	minute0,
	second1,
	second0,
	showout3,
	showout2,
	showout1,
	showout0,
	clk,
	rst_n,
	control
   );

	//input
		input [3:0] minute1, minute0, second1, second0;
		input clk, rst_n;
		input control;

	//output
		output [3:0] showout3, showout2, showout1, showout0;
		
		reg [3:0] showout3, showout2, showout1, showout0;
		reg state, next_state;
		reg mode;
		
	always@*
		case(state)
		`STAT_TIMER:
			if(control)
			begin
				next_state=`STAT_LAP;
				mode=`MODE_LAP;
			end
			else
			begin
				next_state=`STAT_TIMER;
				mode=`MODE_TIMER;
			end
		`STAT_LAP:
			if(control)
			begin		
				next_state=`STAT_TIMER;
				mode=`MODE_TIMER;
				
			end
			else
			begin
				next_state=`STAT_LAP;
				mode=`MODE_LAP;
			end
		default:
			begin
				next_state=`STAT_TIMER;
				mode=`MODE_TIMER;
			end
		endcase
	//transition
	always@(posedge clk or negedge rst_n)
	if(~rst_n)
	 state<=`STAT_TIMER;
	else
	 state<=next_state;
	//decide display
	always@*
		case(mode)
		`MODE_TIMER:
			begin
			showout3=minute1;
			showout2=minute0;
			showout1=second1;	
			showout0=second0;
			end
		`MODE_LAP:
			begin
			showout3=showout3;
			showout2=showout2;
			showout1=showout1;		
			showout0=showout0;
			end
		default:
			begin
			showout3=minute1;
			showout2=minute0;
			showout1=second1;	
			showout0=second0;
			end
		endcase


endmodule
