`timescale 1ns / 1ps
//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    01:56:49 04/25/2016 
// Design Name: 
// Module Name:    upcounter 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////
`define ENABLED 1 // ENABLE indicator
`define DISABLED 0 // EIDABLE indicator
`define INCREMENT 1'b1 // increase by 1
module upcounter(
   value, //counter value
	carry, // carry out to enable counting in next stage
	clk, //global clock
	rst_n, // active low reset
	increase, // enable control of the counter
	load_default, // enable to load default value
	def_value // default value
	);

	// outputs
	output [3:0] value;  // counter value
	output carry;  // carry out to enable counting for next stag
	// inputs
	input clk;  // global clock
	input rst_n;  // active low reset
	input load_default;  // enable to load default value
	input increase;  // enable control of the counter 
	input [3:0] def_value;  // counter upper limit

	reg [3:0] value; // output (in always block)
	reg [3:0] value_tmp; // input to dff (in always block)
	reg carry; // carry out indicator for counter to next stage 

	// combinational part for BCD counter 
	always @*
	  if (increase==`DISABLED&&load_default==`DISABLED)
		 value_tmp = value;
	  else if (load_default==`ENABLED)
		 value_tmp = def_value;
	  else if ((increase==`ENABLED)&&(value==4'd9))
		 value_tmp = 4'd0;
	  else
		 value_tmp = value + `INCREMENT;

	always @*
	  if ((increase==`ENABLED)&&(value == 4'd9))
		 carry = `ENABLED;
	  else
		 carry = `DISABLED;

	// register part for BCD counter
	always @(posedge clk or negedge rst_n)
	  if (~rst_n) value <= def_value;
	  else value <= value_tmp;


endmodule
